<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>ExoXsessionClient: Exo Reference Manual</title>
<meta name="generator" content="DocBook XSL Stylesheets V1.78.1">
<link rel="home" href="index.html" title="Exo Reference Manual">
<link rel="up" href="exo-miscelleanous.html" title="Part VII. Miscelleanous">
<link rel="prev" href="exo-Miscellaneous-Utility-Functions.html" title="Miscellaneous Utility Functions">
<link rel="next" href="exo-tools.html" title="Part VIII. Tools">
<meta name="generator" content="GTK-Doc V1.24 (XML mode)">
<link rel="stylesheet" href="style.css" type="text/css">
</head>
<body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF">
<table class="navigation" id="top" width="100%" summary="Navigation header" cellpadding="2" cellspacing="5"><tr valign="middle">
<td width="100%" align="left" class="shortcuts">
<a href="#" class="shortcut">Top</a><span id="nav_description">  <span class="dim">|</span> 
                  <a href="#ExoXsessionClient.description" class="shortcut">Description</a></span><span id="nav_hierarchy">  <span class="dim">|</span> 
                  <a href="#ExoXsessionClient.object-hierarchy" class="shortcut">Object Hierarchy</a></span><span id="nav_properties">  <span class="dim">|</span> 
                  <a href="#ExoXsessionClient.properties" class="shortcut">Properties</a></span><span id="nav_signals">  <span class="dim">|</span> 
                  <a href="#ExoXsessionClient.signals" class="shortcut">Signals</a></span>
</td>
<td><a accesskey="h" href="index.html"><img src="home.png" width="16" height="16" border="0" alt="Home"></a></td>
<td><a accesskey="u" href="exo-miscelleanous.html"><img src="up.png" width="16" height="16" border="0" alt="Up"></a></td>
<td><a accesskey="p" href="exo-Miscellaneous-Utility-Functions.html"><img src="left.png" width="16" height="16" border="0" alt="Prev"></a></td>
<td><a accesskey="n" href="exo-tools.html"><img src="right.png" width="16" height="16" border="0" alt="Next"></a></td>
</tr></table>
<div class="refentry">
<a name="ExoXsessionClient"></a><div class="titlepage"></div>
<div class="refnamediv"><table width="100%"><tr>
<td valign="top">
<h2><span class="refentrytitle"><a name="ExoXsessionClient.top_of_page"></a>ExoXsessionClient</span></h2>
<p>ExoXsessionClient — Lightweight session management support</p>
</td>
<td class="gallery_image" valign="top" align="right"></td>
</tr></table></div>
<div class="refsect1">
<a name="ExoXsessionClient.functions"></a><h2>Functions</h2>
<div class="informaltable"><table width="100%" border="0">
<colgroup>
<col width="150px" class="functions_return">
<col class="functions_name">
</colgroup>
<tbody>
<tr>
<td class="function_type">
<a class="link" href="ExoXsessionClient.html" title="ExoXsessionClient"><span class="returnvalue">ExoXsessionClient</span></a> *
</td>
<td class="function_name">
<a class="link" href="ExoXsessionClient.html#exo-xsession-client-new-with-group" title="exo_xsession_client_new_with_group ()">exo_xsession_client_new_with_group</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<a href="http://developer.gnome.org/gdk2/gdk3-Windows.html#GdkWindow"><span class="returnvalue">GdkWindow</span></a> *
</td>
<td class="function_name">
<a class="link" href="ExoXsessionClient.html#exo-xsession-client-get-group" title="exo_xsession_client_get_group ()">exo_xsession_client_get_group</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">void</span>
</td>
<td class="function_name">
<a class="link" href="ExoXsessionClient.html#exo-xsession-client-set-group" title="exo_xsession_client_set_group ()">exo_xsession_client_set_group</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<a href="https://developer.gnome.org/glib/unstable/glib-Basic-Types.html#gboolean"><span class="returnvalue">gboolean</span></a>
</td>
<td class="function_name">
<a class="link" href="ExoXsessionClient.html#exo-xsession-client-get-restart-command" title="exo_xsession_client_get_restart_command ()">exo_xsession_client_get_restart_command</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">void</span>
</td>
<td class="function_name">
<a class="link" href="ExoXsessionClient.html#exo-xsession-client-set-restart-command" title="exo_xsession_client_set_restart_command ()">exo_xsession_client_set_restart_command</a> <span class="c_punctuation">()</span>
</td>
</tr>
</tbody>
</table></div>
</div>
<div class="refsect1">
<a name="ExoXsessionClient.properties"></a><h2>Properties</h2>
<div class="informaltable"><table border="0">
<colgroup>
<col width="150px" class="properties_type">
<col width="300px" class="properties_name">
<col width="200px" class="properties_flags">
</colgroup>
<tbody>
<tr>
<td class="property_type">
<a href="http://developer.gnome.org/gdk2/gdk3-Windows.html#GdkWindow"><span class="type">GdkWindow</span></a> *</td>
<td class="property_name"><a class="link" href="ExoXsessionClient.html#ExoXsessionClient--group" title="The “group” property">group</a></td>
<td class="property_flags">Read / Write</td>
</tr>
<tr>
<td class="property_type"><a href="https://developer.gnome.org/gobject/unstable/gobject-Boxed-Types.html#GStrv"><span class="type">GStrv</span></a></td>
<td class="property_name"><a class="link" href="ExoXsessionClient.html#ExoXsessionClient--restart-command" title="The “restart-command” property">restart-command</a></td>
<td class="property_flags">Read / Write</td>
</tr>
</tbody>
</table></div>
</div>
<div class="refsect1">
<a name="ExoXsessionClient.signals"></a><h2>Signals</h2>
<div class="informaltable"><table border="0">
<colgroup>
<col width="150px" class="signals_return">
<col width="300px" class="signals_name">
<col width="200px" class="signals_flags">
</colgroup>
<tbody><tr>
<td class="signal_type"><span class="returnvalue">void</span></td>
<td class="signal_name"><a class="link" href="ExoXsessionClient.html#ExoXsessionClient-save-yourself" title="The “save-yourself” signal">save-yourself</a></td>
<td class="signal_flags"><a href="https://developer.gnome.org/gobject/unstable/gobject-Signals.html#G-SIGNAL-RUN-FIRST:CAPS">Run First</a></td>
</tr></tbody>
</table></div>
</div>
<div class="refsect1">
<a name="ExoXsessionClient.other"></a><h2>Types and Values</h2>
<div class="informaltable"><table width="100%" border="0">
<colgroup>
<col width="150px" class="name">
<col class="description">
</colgroup>
<tbody><tr>
<td class="datatype_keyword">struct</td>
<td class="function_name"><a class="link" href="ExoXsessionClient.html#ExoXsessionClient-struct" title="struct ExoXsessionClient">ExoXsessionClient</a></td>
</tr></tbody>
</table></div>
</div>
<div class="refsect1">
<a name="ExoXsessionClient.object-hierarchy"></a><h2>Object Hierarchy</h2>
<pre class="screen">    <a href="https://developer.gnome.org/gobject/unstable/gobject-The-Base-Object-Type.html#GObject">GObject</a>
    <span class="lineart">╰──</span> ExoXsessionClient
</pre>
</div>
<div class="refsect1">
<a name="ExoXsessionClient.includes"></a><h2>Includes</h2>
<pre class="synopsis">#include &lt;exo/exo.h&gt;
</pre>
</div>
<div class="refsect1">
<a name="ExoXsessionClient.description"></a><h2>Description</h2>
<p>This module provides application developers with lightweight
session management functions, based on the X11R5 session management
protocol. The X11R5 session management protocol is very limited in
its functionality and flexibility compared to the newer X11R6
session management protocol (XSMP), but - on the other hand - offers several
advantages for applications that do not need the complicated features
of the XSMP. Most importantly, the setup is much easier and
faster than with XSMP, because no special actions must be taken.</p>
<p>So, in case your application is simple in its session management
requirements, e.g. it only needs to tell the session manager
its restart command, you may want to use the <a class="link" href="ExoXsessionClient.html" title="ExoXsessionClient"><span class="type">ExoXsessionClient</span></a>
instead of a full featured XSMP client.</p>
<p>Lets say, for example, you are developing a text editor, which
should provide basic session management support, limited to
proper restarting all editor windows that where left open
when you logged off the X session. In case the user was editing
a file when logging off, the same file should be opened in the
window on next startup.</p>
<div class="example">
<a name="id-1.8.7.9.5"></a><p class="title"><b>Example 4. Texteditor with <span class="structname">ExoXsessionClient</span></b></p>
<div class="example-contents"><pre class="programlisting">
static gchar *open_file_name = NULL;

static void
save_yourself (ExoXsessionClient *client)
{
  gchar *argv[2];

  if (open_file_name != NULL)
    {
      argv[0] = "myeditor";
      argv[1] = open_file_name;

      exo_xsession_client_set_restart_command (client, argv, 2);
    }
  else
    {
      argv[0] = "myeditor";

      exo_xsession_client_set_restart_command (client, argv, 1);
    }
}

// ...

int
main (int argc, char **argv)
{
  ExoXsessionClient *client;
  GdkDisplay        *display;
  GdkWindow         *leader;
  GtkWidget         *window;

  gtk_init (&amp;argc, &amp;argv);

  if (argc &gt; 1)
    open_file_name = argv[1];

  // create the main window
  window = create_window ();

  // setup the session client
  display = gtk_widget_get_display (window);
  leader = gdk_display_get_default_group (display);
  client = exo_xsession_client_new_with_group (leader);
  g_signal_connect (G_OBJECT (client), "save-yourself",
                    G_CALLBACK (save_yourself), NULL);

  // ...
}
</pre></div>
</div>
<br class="example-break"><p>This example demonstrates the basic handling of <a class="link" href="ExoXsessionClient.html" title="ExoXsessionClient"><span class="type">ExoXsessionClient</span></a>. It is
oversimplified, but we hope you get the point. The rule of thumb is, use
<a class="link" href="ExoXsessionClient.html" title="ExoXsessionClient"><span class="type">ExoXsessionClient</span></a> if you can store all session data in the restart command,
else use a full-featured XSMP client.</p>
</div>
<div class="refsect1">
<a name="ExoXsessionClient.functions_details"></a><h2>Functions</h2>
<div class="refsect2">
<a name="exo-xsession-client-new-with-group"></a><h3>exo_xsession_client_new_with_group ()</h3>
<pre class="programlisting"><a class="link" href="ExoXsessionClient.html" title="ExoXsessionClient"><span class="returnvalue">ExoXsessionClient</span></a> *
exo_xsession_client_new_with_group (<em class="parameter"><code><a href="http://developer.gnome.org/gdk2/gdk3-Windows.html#GdkWindow"><span class="type">GdkWindow</span></a> *leader</code></em>);</pre>
<p>Creates a new <a class="link" href="ExoXsessionClient.html" title="ExoXsessionClient"><span class="type">ExoXsessionClient</span></a> and associates it
with the group, which is lead by <em class="parameter"><code>leader</code></em>
.</p>
<div class="refsect3">
<a name="id-1.8.7.10.2.5"></a><h4>Parameters</h4>
<div class="informaltable"><table width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody><tr>
<td class="parameter_name"><p>leader</p></td>
<td class="parameter_description"><p>The client leader window of the group.</p></td>
<td class="parameter_annotations"> </td>
</tr></tbody>
</table></div>
</div>
<div class="refsect3">
<a name="id-1.8.7.10.2.6"></a><h4>Returns</h4>
<p> A newly allocated <a class="link" href="ExoXsessionClient.html" title="ExoXsessionClient"><span class="type">ExoXsessionClient</span></a>.</p>
</div>
</div>
<hr>
<div class="refsect2">
<a name="exo-xsession-client-get-group"></a><h3>exo_xsession_client_get_group ()</h3>
<pre class="programlisting"><a href="http://developer.gnome.org/gdk2/gdk3-Windows.html#GdkWindow"><span class="returnvalue">GdkWindow</span></a> *
exo_xsession_client_get_group (<em class="parameter"><code><a class="link" href="ExoXsessionClient.html" title="ExoXsessionClient"><span class="type">ExoXsessionClient</span></a> *client</code></em>);</pre>
<p>Returns the client leader window of the group with which
the <em class="parameter"><code>client</code></em>
 is associated or <a href="https://developer.gnome.org/glib/unstable/glib-Standard-Macros.html#NULL:CAPS"><code class="literal">NULL</code></a> if <em class="parameter"><code>client</code></em>
 is not
associated with any group.</p>
<div class="refsect3">
<a name="id-1.8.7.10.3.5"></a><h4>Parameters</h4>
<div class="informaltable"><table width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody><tr>
<td class="parameter_name"><p>client</p></td>
<td class="parameter_description"><p>An <a class="link" href="ExoXsessionClient.html" title="ExoXsessionClient"><span class="type">ExoXsessionClient</span></a>.</p></td>
<td class="parameter_annotations"> </td>
</tr></tbody>
</table></div>
</div>
<div class="refsect3">
<a name="id-1.8.7.10.3.6"></a><h4>Returns</h4>
<p> The client leader window of the group with which <em class="parameter"><code>client</code></em>
is
associated or <a href="https://developer.gnome.org/glib/unstable/glib-Standard-Macros.html#NULL:CAPS"><code class="literal">NULL</code></a>.</p>
</div>
</div>
<hr>
<div class="refsect2">
<a name="exo-xsession-client-set-group"></a><h3>exo_xsession_client_set_group ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>
exo_xsession_client_set_group (<em class="parameter"><code><a class="link" href="ExoXsessionClient.html" title="ExoXsessionClient"><span class="type">ExoXsessionClient</span></a> *client</code></em>,
                               <em class="parameter"><code><a href="http://developer.gnome.org/gdk2/gdk3-Windows.html#GdkWindow"><span class="type">GdkWindow</span></a> *leader</code></em>);</pre>
<p>Sets the group according to the specified <em class="parameter"><code>leader</code></em>
.</p>
<div class="refsect3">
<a name="id-1.8.7.10.4.5"></a><h4>Parameters</h4>
<div class="informaltable"><table width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>client</p></td>
<td class="parameter_description"><p>An <a class="link" href="ExoXsessionClient.html" title="ExoXsessionClient"><span class="type">ExoXsessionClient</span></a>.</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>leader</p></td>
<td class="parameter_description"><p>The client leader window of a group or <a href="https://developer.gnome.org/glib/unstable/glib-Standard-Macros.html#NULL:CAPS"><code class="literal">NULL</code></a>.</p></td>
<td class="parameter_annotations"> </td>
</tr>
</tbody>
</table></div>
</div>
</div>
<hr>
<div class="refsect2">
<a name="exo-xsession-client-get-restart-command"></a><h3>exo_xsession_client_get_restart_command ()</h3>
<pre class="programlisting"><a href="https://developer.gnome.org/glib/unstable/glib-Basic-Types.html#gboolean"><span class="returnvalue">gboolean</span></a>
exo_xsession_client_get_restart_command
                               (<em class="parameter"><code><a class="link" href="ExoXsessionClient.html" title="ExoXsessionClient"><span class="type">ExoXsessionClient</span></a> *client</code></em>,
                                <em class="parameter"><code><a href="https://developer.gnome.org/glib/unstable/glib-Basic-Types.html#gchar"><span class="type">gchar</span></a> ***argv</code></em>,
                                <em class="parameter"><code><a href="https://developer.gnome.org/glib/unstable/glib-Basic-Types.html#gint"><span class="type">gint</span></a> *argc</code></em>);</pre>
<p>Retrieves the restart command previously set on <em class="parameter"><code>client</code></em>
. The
result is stored in <em class="parameter"><code>argv</code></em>
 and should be freed using
<a href="https://developer.gnome.org/glib/unstable/glib-String-Utility-Functions.html#g-strfreev"><code class="function">g_strfreev()</code></a> when no longer needed.</p>
<p>See <a class="link" href="ExoXsessionClient.html#exo-xsession-client-set-restart-command" title="exo_xsession_client_set_restart_command ()"><code class="function">exo_xsession_client_set_restart_command()</code></a> for further
explanation.</p>
<div class="refsect3">
<a name="id-1.8.7.10.5.6"></a><h4>Parameters</h4>
<div class="informaltable"><table width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>client</p></td>
<td class="parameter_description"><p>An <a class="link" href="ExoXsessionClient.html" title="ExoXsessionClient"><span class="type">ExoXsessionClient</span></a>.</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>argv</p></td>
<td class="parameter_description"><p>Pointer to the location where the
pointer to the argument vector should
be stored to.</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>argc</p></td>
<td class="parameter_description"><p>Pointer to the location where the
number of arguments should be stored
to or <a href="https://developer.gnome.org/glib/unstable/glib-Standard-Macros.html#NULL:CAPS"><code class="literal">NULL</code></a>.</p></td>
<td class="parameter_annotations"> </td>
</tr>
</tbody>
</table></div>
</div>
<div class="refsect3">
<a name="id-1.8.7.10.5.7"></a><h4>Returns</h4>
<p> <a href="https://developer.gnome.org/glib/unstable/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a> on success, else <a href="https://developer.gnome.org/glib/unstable/glib-Standard-Macros.html#FALSE:CAPS"><code class="literal">FALSE</code></a>.</p>
</div>
</div>
<hr>
<div class="refsect2">
<a name="exo-xsession-client-set-restart-command"></a><h3>exo_xsession_client_set_restart_command ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>
exo_xsession_client_set_restart_command
                               (<em class="parameter"><code><a class="link" href="ExoXsessionClient.html" title="ExoXsessionClient"><span class="type">ExoXsessionClient</span></a> *client</code></em>,
                                <em class="parameter"><code><a href="https://developer.gnome.org/glib/unstable/glib-Basic-Types.html#gchar"><span class="type">gchar</span></a> **argv</code></em>,
                                <em class="parameter"><code><a href="https://developer.gnome.org/glib/unstable/glib-Basic-Types.html#gint"><span class="type">gint</span></a> argc</code></em>);</pre>
<p>Sets the <code class="literal">WM_COMMAND</code> property on the client leader window,
which instructs the session manager (or session-enabled window
manager) how to restart the application on next login.</p>
<p>This function can only be used if <em class="parameter"><code>client</code></em>
 is associated with
a client leader window.</p>
<p>If <em class="parameter"><code>argc</code></em>
 is specify as -1, the argument vector <em class="parameter"><code>argv</code></em>
 is expected
to be <a href="https://developer.gnome.org/glib/unstable/glib-Standard-Macros.html#NULL:CAPS"><code class="literal">NULL</code></a>-terminated and <em class="parameter"><code>argc</code></em>
 will be automatically
calculated from <em class="parameter"><code>argv</code></em>
.</p>
<p>Please take note, that <a href="http://developer.gnome.org/gtk2/gtk3-General.html#gtk-init"><code class="function">gtk_init()</code></a> automatically sets the
<code class="literal">WM_COMMAND</code> property on all client leader windows that are
implicitly created by Gtk+. So, you may only need to call
this function in response to the ::save-yourself signal.</p>
<div class="refsect3">
<a name="id-1.8.7.10.6.8"></a><h4>Parameters</h4>
<div class="informaltable"><table width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>client</p></td>
<td class="parameter_description"><p>An <a class="link" href="ExoXsessionClient.html" title="ExoXsessionClient"><span class="type">ExoXsessionClient</span></a>.</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>argv</p></td>
<td class="parameter_description"><p>The argument vector.</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>argc</p></td>
<td class="parameter_description"><p>The number of arguments in <em class="parameter"><code>argv</code></em>
or -1.</p></td>
<td class="parameter_annotations"> </td>
</tr>
</tbody>
</table></div>
</div>
</div>
</div>
<div class="refsect1">
<a name="ExoXsessionClient.other_details"></a><h2>Types and Values</h2>
<div class="refsect2">
<a name="ExoXsessionClient-struct"></a><h3>struct ExoXsessionClient</h3>
<pre class="programlisting">struct ExoXsessionClient;</pre>
<p>The ExoXsessionClient struct contains only private fields and should
not be directly accessed.</p>
</div>
</div>
<div class="refsect1">
<a name="ExoXsessionClient.property-details"></a><h2>Property Details</h2>
<div class="refsect2">
<a name="ExoXsessionClient--group"></a><h3>The <code class="literal">“group”</code> property</h3>
<pre class="programlisting">  “group”                    <a href="http://developer.gnome.org/gdk2/gdk3-Windows.html#GdkWindow"><span class="type">GdkWindow</span></a> *</pre>
<p>Window group leader.</p>
<p>Flags: Read / Write</p>
</div>
<hr>
<div class="refsect2">
<a name="ExoXsessionClient--restart-command"></a><h3>The <code class="literal">“restart-command”</code> property</h3>
<pre class="programlisting">  “restart-command”          <a href="https://developer.gnome.org/gobject/unstable/gobject-Boxed-Types.html#GStrv"><span class="type">GStrv</span></a></pre>
<p>Session restart command.</p>
<p>Flags: Read / Write</p>
</div>
</div>
<div class="refsect1">
<a name="ExoXsessionClient.signal-details"></a><h2>Signal Details</h2>
<div class="refsect2">
<a name="ExoXsessionClient-save-yourself"></a><h3>The <code class="literal">“save-yourself”</code> signal</h3>
<pre class="programlisting"><span class="returnvalue">void</span>
user_function (<a class="link" href="ExoXsessionClient.html" title="ExoXsessionClient"><span class="type">ExoXsessionClient</span></a> *client,
               <a href="https://developer.gnome.org/glib/unstable/glib-Basic-Types.html#gpointer"><span class="type">gpointer</span></a>           user_data)</pre>
<p>This signal is emitted when <em class="parameter"><code>client</code></em>
 receives a <code class="literal">WM_SAVE_YOURSELF</code>
message from the session manager or the window manager on the
specified client leader window.</p>
<div class="refsect3">
<a name="id-1.8.7.13.2.5"></a><h4>Parameters</h4>
<div class="informaltable"><table width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>client</p></td>
<td class="parameter_description"><p>An <a class="link" href="ExoXsessionClient.html" title="ExoXsessionClient"><span class="type">ExoXsessionClient</span></a>.</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>user_data</p></td>
<td class="parameter_description"><p>user data set when the signal handler was connected.</p></td>
<td class="parameter_annotations"> </td>
</tr>
</tbody>
</table></div>
</div>
<p>Flags: <a href="https://developer.gnome.org/gobject/unstable/gobject-Signals.html#G-SIGNAL-RUN-FIRST:CAPS">Run First</a></p>
</div>
</div>
</div>
<div class="footer">
<hr>Generated by GTK-Doc V1.24</div>
</body>
</html>